from OpenGL.GLUT import *
from OpenGL.GL import *
from OpenGL.GLE import *
from OpenGL.GLU import *
from math import sin, cos
from time import time
import Objects3D
import sys
import timing

''' This class includes the OpenGL Scene itself and methodes to manipulate it, e.g. by mouse motion'''

class VirtualWorld:
  def __init__(self):
    ''' Set initial parameters'''
    self.object = Objects3D.Objects3D(10,30,100)
    self.dlCone=self.object.displayListCone()
   # Start of mousepointer 
    self.lastx = 0
    self.lasty = 10
    self.lastz= -60
    # Sphere coordinates
    self.xSphere=-10
    self.ySphere=10
    self.zSphere=-4
    self.zMove=0
    self.xMove=0
  
  def drawScene(self):
    ''' This methode describes the complete scene.'''
    # clear the buffer
    glClear(GL_COLOR_BUFFER_BIT | GL_DEPTH_BUFFER_BIT)
    glLoadIdentity()

    glTranslatef(0.0, -10, self.lastz)
    glRotatef(self.lastx, 0.0, 1.0, 0.0)
    glRotatef(self.lasty, 1.0, 0.0, 0.0)
  # moving light
    glLightfv(GL_LIGHT0, GL_POSITION, (-30,10,5, 1))
    
    
    # objects ###############################
    #plane
    glBegin(GL_QUADS)
    glColor3f(0,.5,.8)
    glNormal(0,1,0)
    glVertex3f(-100,0,-100); glVertex3f(100,0,-100); glVertex3f(100,0,100); glVertex3f(-100,0,100)
    glEnd()
    
    # cone 1
    glColor3f(1,0,0)
    glPushMatrix()
    glTranslatef(-20,0,0)
    timing.start()
    glCallList(self.dlCone)
    timing.finish()
    dl=timing.micro()
    glPopMatrix()
    # cone 2
    glColor3f(0,1,0)
    glPushMatrix()
    timing.start()
    self.object.cone()
    timing.finish()
    loop=timing.micro()
    glPopMatrix()
    # #### cone 3
    glColor3f(0,0,1)
    glPushMatrix()
    glTranslate(20,0,0)
    timing.start()
    self.object.arrayCone()
    timing.finish()
    arr=timing.micro()
    glPopMatrix()
    #######################################
    # swap the buffer
    glutSwapBuffers()
    print "dl",dl,"loop",loop,"array",arr

  def resizeScene(self, width, height):
    '''Needed if window size changes.'''
    if height == 0:						# Prevent A Divide By Zero If The Window Is Too Small 
      height = 1

    glViewport(0, 0, width, height)		# Reset The Current Viewport And Perspective Transformation
    glMatrixMode(GL_PROJECTION)
    glLoadIdentity()
    gluPerspective(45.0, float(width)/float(height), 0.1, 100.0)
    glMatrixMode(GL_MODELVIEW)
  
  def activeMouse(self, x, y):
    '''Returns mouse coordinates while any mouse button is pressed.'''
    # store the mouse coordinate
    if self.mouseButton == GLUT_LEFT_BUTTON:
      self.lastx = x
      self.lasty = y
    if self.mouseButton == GLUT_RIGHT_BUTTON:
      self.lastz = y
    # redisplay
    glutPostRedisplay()
  
  def passiveMouse(self, x, y):
    '''Returns mouse coordinates while no mouse button is pressed.'''
    pass
  
  def keyPressed(self, key, mousex, mousey):
    # If escape is pressed, kill everything.
    if key == "\33":
      sys.exit()
  
  def completeMouse(self, button, state, x, y):
    '''Returns mouse coordinates and which button was pressed resp. released.'''
    self.mouseButton = button
    self.buttonState = state
    # redisplay
    glutPostRedisplay()

  def drawIdleScene(self):
    #self.zMove =10 * sin(time()  % 359)
    #self.xMove =10 * cos(time()  % 359)
    self.drawScene()

